/************************************************************************************/
/*  Program name CAPFNDIMP_RESP_REQ_GRP.sql                                         */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

ALTER TRIGGER FND_REQUEST_GROUPS_CT1 DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDIMP_RESP_REQ_GRP';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_RESP_REQ_GRP;

	CURSOR Cur_G IS
	SELECT
		A.*,
		B.Request_Group_ID_N
	FROM
		CFND_REQUEST_GROUPS			A,
		CRST_FND_RESP_REQ_GRP_MAP	B
	WHERE	A.Request_Group_ID	=	B.Request_Group_ID;

	lv_Next_Seq_ID	NUMBER;

BEGIN
	--  RENAME
	UPDATE
		FND_REQUEST_GROUPS
	SET
		Request_Group_Name	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(Request_Group_Name,1,4),Request_Group_Name),
		Description			=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(Description       ,1,4),Description       ),
		Request_Group_Code	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(Request_Group_Code,1,4),Request_Group_Code)
	WHERE	REQUEST_GROUP_ID	IN
				(
				SELECT
					REQUEST_GROUP_ID
				FROM
					CRST_FND_RESP_REQ_GRP
				);

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	FND_REQUEST_GROUPS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_RESP_REQ_GRP_MAP VALUES
			(
			C1.APPLICATION_ID,
			C1.REQUEST_GROUP_ID,
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.Request_Group_Name,4,4),C1.Request_Group_Name),
			C1.APPLICATION_ID,
			lv_Next_Seq_ID,
			C1.REQUEST_GROUP_NAME
			);

			INSERT INTO FND_REQUEST_GROUPS
			VALUES
			(
			C1.APPLICATION_ID,
			lv_Next_Seq_ID,										--REQUEST_GROUP_ID
			C1.REQUEST_GROUP_NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),	--LAST_UPDATED_BY
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),		--CREATED_BY
			C1.LAST_UPDATE_LOGIN,
			C1.DESCRIPTION,
			C1.REQUEST_GROUP_CODE
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	BEGIN
		FOR C2 IN Cur_G LOOP
			INSERT INTO CFND_REQUEST_GROUPS VALUES
			(
				C2.Application_ID,
				C2.Request_Group_ID_N,
				CAPBRIMP_MAPPING.GetOrgMapping(C2.S_ORG_ID),
				CAPBRIMP_MAPPING.GetBGMapping(C2.S_BUSINESS_GROUP_ID)
			);
		END LOOP;
	EXCEPTION
		WHEN OTHERS THEN
			DBMS_OUTPUT.Put_Line(SQLERRM);
			lv_Err_Count	:=	lv_Err_Count + 1;
	END;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

ALTER TRIGGER FND_REQUEST_GROUPS_CT1 ENABLE;
